<template>
  <div>
    <nav
      class="navbar navbar-expand-lg navbar-light"
      style="background-color: #e3f2fd"
    >
      <div class="container-fluid">
        <ul class="nav nav-pills mb-3 mt-3 ml-10" id="pills-tab" role="tablist">
          <li class="nav-item">
            <button
              class="nav-link active"
              id="pills-home-tab"
              data-bs-toggle="pill"
              data-bs-target="#pills-home"
              type="button"
              role="tab"
              aria-controls="pills-home"
              @click="setActiveTab(`table`)"
            >
              Table View
            </button>
          </li>
          <li class="nav-item">
            <button
              class="nav-link"
              id="pills-profile-tab"
              data-bs-toggle="pill"
              data-bs-target="#pills-profile"
              type="button"
              role="tab"
              aria-controls="pills-profile"
              @click="setActiveTab(`graph`)"
            >
              Graph View
            </button>
          </li>
        </ul>
        <div
          class="collapse navbar-collapse"
          id="navbarNavDarkDropdown"
          style="justify-content: flex-end"
        >
          <div class="nav-item dropdown">
            <h5
              class="nav-link dropdown-toggle"
              style="color: #0d6efd"
              id="navbarDarkDropdownMenuLink"
              role="button"
              data-bs-toggle="dropdown"
              aria-expanded="false"
            >
              {{ displayMonth() }}
            </h5>
            <ul
              class="dropdown-menu dropdown-menu-dark"
              aria-labelledby="navbarDarkDropdownMenuLink"
            >
              <li
                v-for="(value, index) in this.$store.getters.getMonthList"
                :key="index"
                @click="onChangeMonth(value)"
              >
                <a class="dropdown-item">{{ value.name }}</a>
              </li>
            </ul>
          </div>
          <div class="nav-item dropdown">
            <h5
              class="nav-link dropdown-toggle"
              style="color: #0d6efd"
              id="navbarDarkDropdownMenuLink"
              role="button"
              data-bs-toggle="dropdown"
              aria-expanded="false"
            >
              {{ displayYear() }}
            </h5>
            <ul
              class="dropdown-menu dropdown-menu-dark"
              aria-labelledby="navbarDarkDropdownMenuLink"
            >
              <li
                v-for="(value, index) in yearList"
                :key="index"
                @click="onChangeYear(value)"
              >
                <a class="dropdown-item">{{ "20" + value }}</a>
              </li>
            </ul>
          </div>
        </div>
      </div>
    </nav>

    <div class="content">
      <div class="content_title">
        <h2>COVID-19: JHUCSSE</h2>
        <p>
          COVID-19 data sourced from Johns Hopkins University, updated every 10
          minutes
        </p>
      </div>
      <Table :data="covidDataForDisplay" v-if="activeTab == `table`" />
      <Graph
        v-else-if="activeTab == `graph`"
        :propsData="covidDataForDisplay"
      />
    </div>
  </div>
</template>

<script>
import axios from "axios";
import Graph from "../components/Graph";
import Table from "../components/Table";
import moment from "moment";

export default {
  name: "MainPage",
  data() {
    return {
      date: {
        date: "",
        month: "",
        year: "",
      },
      yearList: [19, 20, 21, 22],
      selectedMonth: 1,
      selectedYear: 19,
      covidData: [],
      covidDataForDisplay: [],
      isSelected: false,
      activeTab: "table",
    };
  },

  components: {
    Table,
    Graph,
  },

  created() {
    this.getDate();
    this.getCovidData();
  },
  methods: {
    setActiveTab(tab) {
      this.activeTab = tab;
    },
    onChangeMonth(event) {
      this.isSelected = true;
      this.selectedMonth = event.number;
    },
    onChangeYear(event) {
      this.isSelected = true;
      this.selectedYear = event;
    },
    displayMonth() {
      let monthList = this.$store.getters.getMonthList;
      for (let index = 0; index < monthList.length; index++) {
        const element = monthList[index];
        if (element.number == this.selectedMonth) {
          return element.name;
        }
      }
      return "";
    },
    displayYear() {
      for (let index = 0; index < this.yearList.length; index++) {
        const element = this.yearList[index];
        if (element == this.selectedYear) {
          return "20" + element;
        }
      }
      return "";
    },
    filterCovidDataByMonth() {
      const response = this.covidData;
      this.date.date = this.tmpDate.toString();
      this.date.month = this.tmpMonth.toString();
      this.date.year = this.tmpYear;
      let tmpArray = {
        cases: [],
        recovered: [],
        deaths: [],
      };
      for (const value in response.data.recovered) {
        let tmpDate = moment(value).format("M/DD/YY");
        let getMonth = tmpDate.split("/")[0];
        let getYear = tmpDate.split("/")[2];
        if (getMonth == this.tmpMonth && getYear == parseInt(this.date.year)) {
          let ob = {
            date: tmpDate,
            recovered: response.data.recovered[value],
          };
          tmpArray.recovered.push(ob);
        }
      }

      for (const value in response.data.cases) {
        let tmpDate = moment(value).format("M/DD/YY");
        let getMonth = tmpDate.split("/")[0];
        let getYear = tmpDate.split("/")[2];
        if (getMonth == this.tmpMonth && getYear == parseInt(this.date.year)) {
          let ob = {
            date: tmpDate,
            cases: response.data.cases[value],
          };
          tmpArray.cases.push(ob);
        }
      }

      for (const value in response.data.deaths) {
        let tmpDate = moment(value).format("M/DD/YY");
        let getMonth = tmpDate.split("/")[0];
        let getYear = tmpDate.split("/")[2];
        if (getMonth == this.tmpMonth && getYear == parseInt(this.date.year)) {
          let ob = {
            date: tmpDate,
            deaths: response.data.deaths[value],
          };
          tmpArray.deaths.push(ob);
        }
      }

      this.covidDataForDisplay = tmpArray;
    },
    getCovidData() {
      axios
        .get(`https://disease.sh/v3/covid-19/historical/all?lastdays=all`)
        .then((response) => {
          if (response.status == 200) {
            this.covidData = response;
            this.filterCovidDataByMonth();
          } else {
            alert("something went wrong with api");
          }
        });
    },
    getDate() {
      const d = new Date();
      this.tmpDate = d.getDate();
      this.tmpMonth = d.getMonth() + 1;
      this.selectedMonth = this.tmpMonth;
      this.tmpYear = d.getFullYear();
      this.selectedYear = parseInt(this.tmpYear.toString().slice(2, 4));
    },
  },

  watch: {
    selectedMonth(value) {
      this.tmpMonth = value;
      if (this.isSelected) {
        this.filterCovidDataByMonth();
      }
    },
    selectedYear(value) {
      this.tmpYear = value;
      if (this.isSelected) {
        this.filterCovidDataByMonth();
      }
    },
  },
};
</script>

<style scoped>
.content {
  margin-top: 3rem;
  padding-left: 15rem;
  padding-right: 15rem;
}
.content_title {
  padding-bottom: 2rem;
}
</style>
